package autocode

import (
	"github.com/flipped-aurora/gin-vue-admin/server/global"
	"github.com/flipped-aurora/gin-vue-admin/server/model/autocode"
	autoCodeReq "github.com/flipped-aurora/gin-vue-admin/server/model/autocode/request"
	"github.com/flipped-aurora/gin-vue-admin/server/model/common/request"
)

type PlaceProService struct {
}

// CreatePlacePro 创建PlacePro记录
// Author [piexlmax](https://github.com/piexlmax)
func (placeProService *PlaceProService) CreatePlacePro(placePro autocode.PlacePro) (err error) {
	err = global.GVA_DB.Create(&placePro).Error
	return err
}

// DeletePlacePro 删除PlacePro记录
// Author [piexlmax](https://github.com/piexlmax)
func (placeProService *PlaceProService) DeletePlacePro(placePro autocode.PlacePro) (err error) {
	err = global.GVA_DB.Delete(&placePro).Error
	return err
}

// DeletePlaceProByIds 批量删除PlacePro记录
// Author [piexlmax](https://github.com/piexlmax)
func (placeProService *PlaceProService) DeletePlaceProByIds(ids request.IdsReq) (err error) {
	err = global.GVA_DB.Delete(&[]autocode.PlacePro{}, "id in ?", ids.Ids).Error
	return err
}

// UpdatePlacePro 更新PlacePro记录
// Author [piexlmax](https://github.com/piexlmax)
func (placeProService *PlaceProService) UpdatePlacePro(placePro autocode.PlacePro) (err error) {
	err = global.GVA_DB.Save(&placePro).Error
	return err
}

// GetPlacePro 根据id获取PlacePro记录
// Author [piexlmax](https://github.com/piexlmax)
func (placeProService *PlaceProService) GetPlacePro(id uint) (err error, placePro autocode.PlacePro) {
	err = global.GVA_DB.Where("id = ?", id).First(&placePro).Error
	return
}

// GetPlaceProInfoList 分页获取PlacePro记录
// Author [piexlmax](https://github.com/piexlmax)
func (placeProService *PlaceProService) GetPlaceProInfoList(info autoCodeReq.PlaceProSearch) (err error, list interface{}, total int64) {
	limit := info.PageSize
	offset := info.PageSize * (info.Page - 1)
	// 创建db
	db := global.GVA_DB.Model(&autocode.PlacePro{})
	var placePros []autocode.PlacePro
	// 如果有条件搜索 下方会自动创建搜索语句
	err = db.Count(&total).Error
	err = db.Limit(limit).Offset(offset).Find(&placePros).Error
	return err, placePros, total
}

func (placeProService *PlaceProService) GetPlaceProByIds(id uint) (err error, list []autocode.PlacePro) {
	// 创建db
	db := global.GVA_DB.Model(&autocode.PlacePro{})
	var placePros []autocode.PlacePro
	// 如果有条件搜索 下方会自动创建搜索语句
	err = db.Where("place_id = ?", id).Find(&placePros).Error
	return err, placePros
}
